package dev.shadowsoffire.apotheosis.garden;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.garden.GardenModule;
import dev.shadowsoffire.placebo.util.IReplacementBlock;
import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.util.RandomSource;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.LevelReader;
import net.minecraft.world.level.block.BambooStalkBlock;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.state.properties.BambooLeaves;
import net.minecraft.world.level.block.state.properties.Property;

public class ApothBambooBlock extends BambooStalkBlock implements IReplacementBlock {
  protected StateDefinition<Block, BlockState> container;
  
  public ApothBambooBlock() {
    super(BlockBehaviour.Properties.m_60926_((BlockBehaviour)Blocks.f_50571_));
  }
  
  public void m_213898_(BlockState state, ServerLevel worldIn, BlockPos pos, RandomSource random) {
    if (((Integer)state.m_61143_((Property)f_260694_)).intValue() == 0 && 
      random.m_188503_(3) == 0 && worldIn.m_46859_(pos.m_7494_()) && worldIn.m_45524_(pos.m_7494_(), 0) >= 9) {
      int i = m_261132_((BlockGetter)worldIn, pos) + 1;
      if (i < GardenModule.maxBambooHeight)
        m_261305_(state, (Level)worldIn, pos, random, i); 
    } 
  }
  
  public boolean m_7370_(LevelReader worldIn, BlockPos pos, BlockState state, boolean isClient) {
    int i = m_261076_((BlockGetter)worldIn, pos);
    int j = m_261132_((BlockGetter)worldIn, pos);
    return (i + j + 1 < GardenModule.maxBambooHeight && ((Integer)worldIn.m_8055_(pos.m_6630_(i)).m_61143_((Property)f_260694_)).intValue() != 1);
  }
  
  public void m_214148_(ServerLevel worldIn, RandomSource rand, BlockPos pos, BlockState state) {
    int bambooAbove = m_261076_((BlockGetter)worldIn, pos);
    int bambooBelow = m_261132_((BlockGetter)worldIn, pos);
    int bambooSize = bambooAbove + bambooBelow + 1;
    int l = 1 + rand.m_188503_(2);
    for (int i1 = 0; i1 < l; i1++) {
      BlockPos blockpos = pos.m_6630_(bambooAbove);
      BlockState blockstate = worldIn.m_8055_(blockpos);
      if (bambooSize >= GardenModule.maxBambooHeight || ((Integer)blockstate.m_61143_((Property)f_260694_)).intValue() == 1 || !worldIn.m_46859_(blockpos.m_7494_()))
        return; 
      m_261305_(blockstate, (Level)worldIn, blockpos, rand, bambooSize);
      bambooAbove++;
      bambooSize++;
    } 
  }
  
  protected int m_261076_(BlockGetter worldIn, BlockPos pos) {
    int i;
    for (i = 0; i < GardenModule.maxBambooHeight && worldIn.m_8055_(pos.m_6630_(i + 1)).m_60734_() == Blocks.f_50571_; i++);
    return i;
  }
  
  protected int m_261132_(BlockGetter worldIn, BlockPos pos) {
    int i;
    for (i = 0; i < GardenModule.maxBambooHeight && worldIn.m_8055_(pos.m_6625_(i + 1)).m_60734_() == Blocks.f_50571_; i++);
    return i;
  }
  
  protected void m_261305_(BlockState blockStateIn, Level worldIn, BlockPos posIn, RandomSource rand, int size) {
    BlockState blockstate = worldIn.m_8055_(posIn.m_7495_());
    BlockPos blockpos = posIn.m_6625_(2);
    BlockState blockstate1 = worldIn.m_8055_(blockpos);
    BambooLeaves bambooleaves = BambooLeaves.NONE;
    if (size >= 1)
      if (blockstate.m_60734_() == Blocks.f_50571_ && blockstate.m_61143_((Property)f_260716_) != BambooLeaves.NONE) {
        if (blockstate.m_60734_() == Blocks.f_50571_ && blockstate.m_61143_((Property)f_260716_) != BambooLeaves.NONE) {
          bambooleaves = BambooLeaves.LARGE;
          if (blockstate1.m_60734_() == Blocks.f_50571_) {
            worldIn.m_7731_(posIn.m_7495_(), (BlockState)blockstate.m_61124_((Property)f_260716_, (Comparable)BambooLeaves.SMALL), 3);
            worldIn.m_7731_(blockpos, (BlockState)blockstate1.m_61124_((Property)f_260716_, (Comparable)BambooLeaves.NONE), 3);
          } 
        } 
      } else {
        bambooleaves = BambooLeaves.SMALL;
      }  
    int i = (((Integer)blockStateIn.m_61143_((Property)f_260603_)).intValue() != 1 && blockstate1.m_60734_() != Blocks.f_50571_) ? 0 : 1;
    int j = ((size < GardenModule.maxBambooHeight - GardenModule.maxBambooHeight / 5.0D || rand.m_188501_() >= 0.25F) && size != GardenModule.maxBambooHeight - 1) ? 0 : 1;
    worldIn.m_7731_(posIn.m_7494_(), (BlockState)((BlockState)((BlockState)m_49966_().m_61124_((Property)f_260603_, Integer.valueOf(i))).m_61124_((Property)f_260716_, (Comparable)bambooleaves)).m_61124_((Property)f_260694_, Integer.valueOf(j)), 3);
  }
  
  public void _setDefaultState(BlockState state) {
    m_49959_(state);
  }
  
  public void setStateContainer(StateDefinition<Block, BlockState> container) {
    this.container = container;
  }
  
  public StateDefinition<Block, BlockState> m_49965_() {
    return (this.container == null) ? super.m_49965_() : this.container;
  }
}
